From f08c2445abffaa05758e2e7e7a7398cbf401edc0 Mon Sep 17 00:00:00 2001
From: Jonathan Swinney <jswinney@amazon.com>
Date: Thu, 5 Jan 2023 16:01:47 +0000
Subject: [PATCH 4/4] improve pixelavg_pp_neon

before:                                                         after:
         avg_pp[  4x4]  1.00x    94.24           94.43                   avg_pp[  4x4]  1.00x    94.26           94.32
         avg_pp[  8x8]  0.92x    82.81           76.50                   avg_pp[  8x8]  0.98x    77.92           76.61
         avg_pp[  8x4]  2.08x    20.12           41.78                   avg_pp[  8x4]  1.40x    29.46           41.34
         avg_pp[  4x8]  1.00x    78.45           78.06                   avg_pp[  4x8]  1.00x    78.06           77.94
         avg_pp[16x16]  5.58x    217.33          1211.89                 avg_pp[16x16]  5.92x    201.78          1194.24
         avg_pp[ 16x8]  5.91x    102.41          604.75                  avg_pp[ 16x8]  6.62x    91.03           602.47
         avg_pp[ 8x16]  1.00x    176.52          175.77                  avg_pp[ 8x16]  1.02x    175.85          179.74
         avg_pp[ 16x4]  6.46x    46.41           299.94                  avg_pp[ 16x4]  9.42x    31.74           299.15
         avg_pp[16x12]  5.52x    164.51          908.46                  avg_pp[16x12]  6.05x    150.29          908.67
         avg_pp[ 4x16]  1.00x    176.00          175.81                  avg_pp[ 4x16]  1.00x    176.01          175.90
         avg_pp[12x16]  1.98x    462.08          915.88                  avg_pp[12x16]  2.00x    456.62          915.23
         avg_pp[32x32]  0.68x    844.49          576.66                  avg_pp[32x32]  0.97x    604.15          584.11
         avg_pp[32x16]  0.71x    399.91          282.78                  avg_pp[32x16]  0.96x    301.93          289.42
         avg_pp[16x32]  5.49x    441.77          2425.39                 avg_pp[16x32]  5.95x    407.79          2428.23
         avg_pp[ 32x8]  0.69x    191.53          132.00                  avg_pp[ 32x8]  1.00x    136.60          136.29
         avg_pp[32x24]  0.70x    610.22          427.34                  avg_pp[32x24]  0.97x    446.32          434.58
         avg_pp[ 8x32]  1.01x    369.43          373.34                  avg_pp[ 8x32]  1.00x    369.47          369.25
         avg_pp[24x32]  0.79x    619.39          490.24                  avg_pp[24x32]  1.00x    519.09          519.56
         avg_pp[64x64]  0.53x    3896.39         2066.07                 avg_pp[64x64]  1.00x    2057.58         2061.52
         avg_pp[64x32]  0.54x    1908.48         1029.25                 avg_pp[64x32]  1.00x    1024.86         1025.87
         avg_pp[32x64]  0.58x    1917.16         1118.01                 avg_pp[32x64]  0.90x    1257.88         1132.16
         avg_pp[64x16]  0.61x    835.45          509.40                  avg_pp[64x16]  1.00x    508.14          509.66
         avg_pp[64x48]  0.53x    2890.85         1545.81                 avg_pp[64x48]  1.00x    1548.09         1543.55
         avg_pp[16x64]  5.24x    927.07          4854.02                 avg_pp[16x64]  5.57x    860.51          4794.71
         avg_pp[48x64]  0.52x    2977.64         1553.23                 avg_pp[48x64]  1.00x    1550.45         1546.75
---
 source/common/aarch64/pixel-prim.cpp | 14 +++++---------
 1 file changed, 5 insertions(+), 9 deletions(-)

diff --git a/source/common/aarch64/pixel-prim.cpp b/source/common/aarch64/pixel-prim.cpp
index 7c2193c28..7164cd99f 100644
--- a/source/common/aarch64/pixel-prim.cpp
+++ b/source/common/aarch64/pixel-prim.cpp
@@ -1383,18 +1383,14 @@ void pixelavg_pp_neon(pixel *dst, intptr_t dstride, const pixel *src0, intptr_t
         for (; (x + 8) <= lx; x += 8)
         {
 #if HIGH_BIT_DEPTH
-            int16x8_t in0 = *(int16x8_t *)&src0[x];
-            int16x8_t in1 = *(int16x8_t *)&src1[x];
-            int16x8_t t = vaddq_s16(in0, in1);
-            t = vaddq_s16(t, vdupq_n_s16(1));
-            t = vshrq_n_s16(t, 1);
-            *(int16x8_t *)&dst[x] = t;
+            uint16x8_t in0 = *(uint16x8_t *)&src0[x];
+            uint16x8_t in1 = *(uint16x8_t *)&src1[x];
+            uint16x8_t t = vrhaddq_u16(in0, in1);
+            *(uint16x8_t *)&dst[x] = t;
 #else
             int16x8_t in0 = vmovl_u8(*(uint8x8_t *)&src0[x]);
             int16x8_t in1 = vmovl_u8(*(uint8x8_t *)&src1[x]);
-            int16x8_t t = vaddq_s16(in0, in1);
-            t = vaddq_s16(t, vdupq_n_s16(1));
-            t = vshrq_n_s16(t, 1);
+            int16x8_t t = vrhaddq_s16(in0, in1);
             *(uint8x8_t *)&dst[x] = vmovn_u16(t);
 #endif
         }
-- 
2.38.1

